<?php

namespace Treewec\FileSystem;

/**
 * Test class for Filename.
 * Generated by PHPUnit on 2012-03-25 at 16:41:44.
 * @group filesystem
 */
class FilenameTest extends \PHPUnit_Framework_TestCase {

    private $invalidCharacters;
    private $defaultHiddenFiles;
    private $userHiddenFiles;

    protected function setUp() {
        $this->invalidCharacters = array(
            '?', '"', '<', '>', ':', '*', '|',
            '^', ';', ' ', '\\', '../', '..', '\\'
        );
        $this->defaultHiddenFiles = array('.htaccess', '.htpasswd', 'dir.order');
        $this->userHiddenFiles = explode(';', TREEWEC_USER_HIDDEN_FILES);
    }
    
    public function testIsValid() {        
        parent::assertTrue(Path::isValid("hello/world"));

        parent::assertFalse(Path::isValid(null));
        foreach ($this->invalidCharacters as $invalidChar) {
            parent::assertFalse(Path::isValid("hello/world" . $invalidChar));
        }
    }

    public function testIsHidden() {
        // default hidden filenames
        foreach ($this->defaultHiddenFiles as $filename) {
            parent::assertTrue(Filename::isHidden($filename));
        }
        // user 
        foreach ($this->userHiddenFiles as $filename) {
            parent::assertTrue(Filename::isHidden($filename));
        }
        // hidden if name have prefix
        parent::assertTrue(Filename::isHidden(TREEWEC_PREFIX_OF_HIDDEN_FILES . 'name'));
        parent::assertFalse(Filename::isHidden('pre' . TREEWEC_PREFIX_OF_HIDDEN_FILES . 'name'));
        parent::assertFalse(Filename::isHidden(null));
    }

}

?>
